#ifndef ATL_dGetNB_geqrf

/*
 * NB selection for GEQRF: Side='RIGHT', Uplo='UPPER'
 * M : 25,96,128,160,192,224,288,416,864,1280,1728,3488
 * N : 25,96,128,160,192,224,288,416,864,1280,1728,3488
 * NB : 4,8,8,8,16,32,32,32,32,32,64,64
 */
#define ATL_dGetNB_geqrf(n_, nb_) \
{ \
   if ((n_) < 60) (nb_) = 4; \
   else if ((n_) < 176) (nb_) = 8; \
   else if ((n_) < 208) (nb_) = 16; \
   else if ((n_) < 1504) (nb_) = 32; \
   else (nb_) = 64; \
}


#endif    /* end ifndef ATL_dGetNB_geqrf */
