#ifndef ATL_dtGetNB_geqrf

/*
 * NB selection for GEQRF: Side='RIGHT', Uplo='UPPER'
 * M : 25,64,160,192,224,256,320,672,832,1024,1376,2784,5568
 * N : 25,64,160,192,224,256,320,672,832,1024,1376,2784,5568
 * NB : 4,8,8,8,24,24,56,40,32,64,64,96,160
 */
#define ATL_dtGetNB_geqrf(n_, nb_) \
{ \
   if ((n_) < 44) (nb_) = 4; \
   else if ((n_) < 208) (nb_) = 8; \
   else if ((n_) < 288) (nb_) = 24; \
   else if ((n_) < 496) (nb_) = 56; \
   else if ((n_) < 752) (nb_) = 40; \
   else if ((n_) < 928) (nb_) = 32; \
   else if ((n_) < 2080) (nb_) = 64; \
   else if ((n_) < 4176) (nb_) = 96; \
   else (nb_) = 160; \
}


#endif    /* end ifndef ATL_dtGetNB_geqrf */
